# Generated by Django 4.1.5 on 2023-03-30 08:20

from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("isa", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Checklist",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "original_id",
                    models.CharField(
                        blank=True,
                        help_text="ID of checklist",
                        max_length=50,
                        null=True,
                    ),
                ),
                (
                    "name",
                    models.CharField(help_text="Name of checklist", max_length=100),
                ),
                (
                    "version",
                    models.CharField(
                        blank=True,
                        help_text="Version of checklist",
                        max_length=50,
                        null=True,
                    ),
                ),
                (
                    "description",
                    models.TextField(
                        blank=True, help_text="Description of checklist", null=True
                    ),
                ),
                (
                    "instruction",
                    models.TextField(
                        blank=True, help_text="Checklist instructions", null=True
                    ),
                ),
                (
                    "url",
                    models.URLField(blank=True, help_text="URL checklist", null=True),
                ),
                (
                    "rawfile",
                    models.FileField(
                        blank=True,
                        help_text="RAW checklist file",
                        null=True,
                        upload_to="",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Database",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(help_text="Name of database", max_length=50)),
                (
                    "url",
                    models.URLField(blank=True, help_text="URL database", null=True),
                ),
                (
                    "urlImage",
                    models.URLField(blank=True, help_text="URL logo", null=True),
                ),
                (
                    "description",
                    models.TextField(
                        blank=True, help_text="Description of database", null=True
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Metadata",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "short_description",
                    models.TextField(
                        blank=True, help_text="Short description", null=True
                    ),
                ),
                (
                    "table",
                    models.JSONField(blank=True, help_text="metadata table", null=True),
                ),
                (
                    "metadata",
                    models.JSONField(blank=True, help_text="metadata table", null=True),
                ),
                (
                    "created_date",
                    models.DateTimeField(default=django.utils.timezone.now),
                ),
                (
                    "created_by",
                    models.CharField(
                        help_text="Created by XXX (Username)", max_length=50
                    ),
                ),
                (
                    "last_modification_date",
                    models.DateTimeField(default=django.utils.timezone.now),
                ),
                (
                    "last_modification_by",
                    models.CharField(
                        help_text="Last modification by XXX (Username)", max_length=50
                    ),
                ),
                ("mandatory", models.IntegerField(default=0)),
                ("recommended", models.IntegerField(default=0)),
                ("optional", models.IntegerField(default=0)),
                (
                    "checklist",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="metadata.checklist",
                    ),
                ),
                (
                    "study",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="isa.study"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Field",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(help_text="Name of field", max_length=50)),
                (
                    "description",
                    models.TextField(
                        blank=True, help_text="Name of field", max_length=50, null=True
                    ),
                ),
                (
                    "format",
                    models.CharField(
                        blank=True, help_text="Name of field", max_length=50, null=True
                    ),
                ),
                (
                    "restriction",
                    models.TextField(
                        blank=True, help_text="Field restriction", null=True
                    ),
                ),
                (
                    "requirement",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("recommended", "recommended"),
                            ("optional", "optional"),
                            ("mandatory", "mandatory"),
                        ],
                        default="mandatory",
                        help_text="Field requirement",
                        max_length=50,
                        null=True,
                    ),
                ),
                (
                    "unit",
                    models.TextField(blank=True, help_text="Field unit", null=True),
                ),
                (
                    "group",
                    models.TextField(blank=True, help_text="Field unit", null=True),
                ),
                (
                    "example",
                    models.TextField(blank=True, help_text="Field example", null=True),
                ),
                (
                    "checklist",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="metadata.checklist",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="checklist",
            name="database",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="metadata.database"
            ),
        ),
    ]
